# $Id: findutils.spec,v 1.7 2003/10/29 19:08:28 solar Exp $

Summary: The GNU versions of find utilities (find and xargs).
Name: findutils
Version: 4.1.7
Release: owl2
Epoch: 1
License: GPL
Group: Applications/File
Source0: ftp://alpha.gnu.org/gnu/%name-%version.tar.gz
Patch0: findutils-4.1.7-rh-doc.diff
Patch1: findutils-4.1.7-owl-delete.diff
Patch2: findutils-4.1.7-owl-warnings.diff
Patch3: findutils-4.1.7-owl-info.diff
PreReq: /sbin/install-info
BuildRoot: /override/%name-%version

%description
The findutils package contains programs which will help you locate
files on your system.  The find utility searches through a hierarchy
of directories looking for files which match a certain set of criteria
(such as a filename pattern).  The xargs utility builds and executes
command lines from standard input arguments (usually lists of file
names generated by the find command).

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%{expand:%%define optflags %optflags -Wall}

%build
rm doc/find.info
%configure
make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall

%post
/sbin/install-info %_infodir/find.info.gz %_infodir/dir

%preun
if [ $1 -eq 0 ]; then
	/sbin/install-info --delete %_infodir/find.info.gz %_infodir/dir
fi

%files
%defattr(-,root,root)
%doc NEWS README
%_bindir/find
%_bindir/xargs
%_mandir/man1/find.1*
%_mandir/man1/xargs.1*
%_infodir/find.info*

%changelog
* Mon Aug 19 2002 Michail Litvak <mci@owl.openwall.com> 1:4.1.7-owl2
- Deal with info dir entries such that the menu looks pretty.

* Tue May 14 2002 Solar Designer <solar@owl.openwall.com>
- Updated to 4.1.7.

* Fri Feb 01 2002 Solar Designer <solar@owl.openwall.com>
- Build with -Wall; this produces very few warnings which should be
dealt with at next update.

* Fri Feb 01 2002 Michail Litvak <mci@owl.openwall.com>
- Enforce our new spec file conventions.

* Sat Sep 23 2000 Alexandr D. Kanevskiy <kad@owl.openwall.com>
- import spec from RH
- import "-delete" patch by Douglas Siebert <douglas-siebert@uiowa.edu>
