# $Id: procmail.spec,v 1.6 2003/10/30 21:15:47 solar Exp $

Summary: The procmail mail processing program.
Name: procmail
Version: 3.15.2
Release: owl2
License: GPL or Artistic License
Group: System Environment/Daemons
Source: ftp://ftp.procmail.org/pub/procmail/procmail-%version.tar.gz
Patch0: procmail-3.15.2-owl-config.diff
Patch1: procmail-3.15.2-owl-fixes.diff
BuildRequires: mktemp >= 1:1.3.1
BuildRoot: /override/%name-%version

%description
procmail is a mail processing program which can be used to filter,
sort, or selectively forward e-mail messages.  Optionally, procmail
may be installed as the local delivery agent.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
make \
	LOCKINGTEST=100 \
	SEARCHLIBS="-lm -lnsl -ldl" \
	CC=gcc \
	CFLAGS0="$RPM_OPT_FLAGS -Wall -Wno-comment -Wno-parentheses"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT{%_bindir,%_mandir/man{1,5}}

make install \
	BASENAME=$RPM_BUILD_ROOT%_prefix \
	MANDIR=$RPM_BUILD_ROOT%_mandir

%files
%defattr(-,root,root)
%doc FAQ HISTORY README KNOWN_BUGS FEATURES COPYING Artistic examples
%attr(755,root,root) %_bindir/formail
%attr(755,root,root) %_bindir/lockfile
%attr(755,root,root) %_bindir/mailstat
%attr(755,root,root) %_bindir/procmail
%_mandir/man[15]/*

%changelog
* Fri Oct 04 2002 Solar Designer <solar@owl.openwall.com> 3.15.2-owl2
- Corrected the mansed script "fix", thanks to Dmitry V. Levin of ALT Linux
for pointing out that it was broken.

* Tue Aug 13 2002 Solar Designer <solar@owl.openwall.com>
- Updated to 3.15.2.
- Added temporary file handling fixes to scripts used during the builds.

* Wed Feb 06 2002 Solar Designer <solar@owl.openwall.com>
- Enforce our new spec file conventions.

* Thu May 10 2001 Solar Designer <solar@owl.openwall.com>
- Don't let procmail get linked against -lnet (our libnet isn't what
procmail thinks it is).

* Wed Nov 15 2000 Solar Designer <solar@owl.openwall.com>
- Checked procmail for a number of possible problems in the handling of
.procmailrc files, produced a patch.
- Decided against installing anything SGID by default (fcntl locking is
sufficient most of the time); owl-control files are to be added.
- Based this spec file on Red Hat's, but changed it heavily.
